#include "PassControl.h"
#include "myFilter.h"


PassControl::PassControl(BRect frame, const char *name, const char *label, const char *initial_text, 
	BMessage *message)
	: 	BTextControl(frame, name, label, initial_text, message) {
	filter = new myFilter();
	((BTextView *)TextView())->AddFilter(filter);
	SetDivider(StringWidth(label) + 2.5);
}

PassControl::~PassControl()
{
	if(((BTextView *)TextView())->RemoveFilter(filter))
	{
		delete filter;
	}
}

void PassControl::SetText(const char *text)
{
	actual = text;
	BString stars;
	for( int ctr = 0; ctr < actual.Length(); ctr++ ) {
		stars << '*';
	}
	BTextControl::SetText( stars.String() );	
}

void PassControl::PopChar()
{
	actual = actual.Remove( actual.Length() - 1, 1 );
}

void PassControl::PushChar(BMessage *msg)
{
	type_code type;
	int32 count;
	msg->GetInfo("byte", &type, &count);
	for (int32 x = 0; x < count; x++)
	{
		int8 byte;
		msg->FindInt8("byte", x, &byte);
		actual << (char)byte;
	}
}

const char *PassControl::actualText() const
{ return actual.String(); }
