// This version of PassControl was written by Joshua Warchol (pavo@csh.rit.edu). It was based
// on the design by John Wiggins (john@ubermensch.net). My version removes the cluncky old 
// c-style string handling and replaces it with simple BString use. The interface for this class 
// remains the same.

#ifndef PASSCONTROL_H
#define PASSCONTROL_H

#include <TextControl.h>
#include <Font.h>
#include <Rect.h>
#include <Message.h>
#include <String.h>
#include "myFilter.h"
class PassControl : public BTextControl {
public:
	PassControl(BRect frame, const char *name, const char *label, const char *initial_text, 
		BMessage *message );
	virtual	~PassControl(); 
	virtual void SetText(const char *text);
	void PopChar(); 
	void PushChar(BMessage* msg); 
	const char *actualText() const; 
private:
	myFilter *filter;
	BString actual;
};

#endif
