//RRClientApp.cpp

#include "RRClientApp.h"

int main()
{
	RRClientApp app;
	app.Run();
	return 0;
}

RRClientApp::RRClientApp():BApplication(APP_SIGNATURE)
{
	while (deskbar.GetItemInfo("RRClient Deskbar View", &db_id) == B_OK)
	{
		deskbar.RemoveItem(db_id);
    }
    
	if (deskbar.AddItem( new RRClientDeskbarView, &db_id) != B_OK)
	{
		(new BAlert("Uh-oh", "Unable to create deskabar replicant","OK"))->Go();
		exit(1);
    }
}

void
RRClientApp::AboutRequested(void)
{
	(new BAlert("About RRClient 2.0", "RRClient 1.5\n\n\t SerphWare\n\t http://serphware.dreamscape.com","OK"))->Go();
}

bool
RRClientApp::QuitRequested(void)
{
	deskbar.RemoveItem(db_id);
	return TRUE;
}

void RRClientApp::MessageReceived(BMessage* message)
{
		switch(message->what)
	{
		case RRCLIENT_EXIT:
			BAlert *alert;
			alert = new BAlert("Exit?", "Are you sure you would like to exit?", "No", "Yes", NULL, B_WIDTH_AS_USUAL, B_OFFSET_SPACING, B_WARNING_ALERT);
			
			if (alert->Go() == 1) 
			{
				deskbar.RemoveItem(db_id);
				be_app->PostMessage(B_QUIT_REQUESTED);
			}
			break;
		case RRCLIENT_OPTIONS:
				options = new RRClientOptionsWindow("RRClient Options", BRect(300, 300, 550, 450));
				options->Show();
			break;
		case RRCLIENT_LOGIN:
				Login();
			break;
		case RRCLIENT_LOGOFF:
				Logoff();
			break;
		default:
			BApplication::MessageReceived(message);
			break;
	}
}

void
RRClientApp::Login()
{
int result = rrlmsLogin();
char result_msg[100];
sprintf(result_msg, GetResultMsg( result ));
(new BAlert("Result", result_msg,"OK"))->Go();
}

void
RRClientApp::Logoff()
{
int result = rrlmsLogoff();
char result_msg[100];
sprintf(result_msg, GetResultMsg( result ));
(new BAlert("Result", result_msg,"OK"))->Go();
}

const char*
RRClientApp::GetResultMsg( int result )
{
        const char* message;
        switch(result)
                {
                        case SOCKET_ERROR:
                                message = SOCKET_ERROR_MSG;
                                break;
                        case SERVER_CONNECT_ERROR:
                                message = SERVER_CONNECT_ERROR_MSG;
                                break;
                        case SERVER_RECIEVE_ERROR:
                                message = SERVER_RECIEVE_ERROR_MSG;
                                break;
                        case UNEXPECTED_PACKET_ERROR:
                                message = UNEXPECTED_PACKET_ERROR_MSG;
                                break;
                        case SUCCESSFUL_LOGOUT:
                                message = SUCCESSFUL_LOGOUT_MSG;
                                break;
                        case UNSUCCESSFUL_LOGOUT:
                                message = UNSUCCESSFUL_LOGOUT_MSG;
                                break;
                        case SETTINGS_FILE_ERROR:
                                message = SETTINGS_FILE_ERROR_MSG;
                                break;
                        case UNEXPECTED_RESPONSE:
                                message = UNEXPECTED_RESPONSE_MSG;
                                break;
                        case UNSUCCESSFUL_LOGIN:
                                message = UNSUCCESSFUL_LOGIN_MSG;
                                break;
                        case SUCCESSFUL_LOGIN:
                                message = SUCCESSFUL_LOGIN_MSG;
                                break;
                        default:
                                message = "Unknown Error!\n";
                }
        return message;
}
