//RRClientDeskbarView.cpp

#include "RRClientDeskbarView.h"

RRClientDeskbarView::RRClientDeskbarView():BView(BRect(0,0,15,15),
    "RRClient Deskbar View", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW) 
{
	app_info info;
    be_app->GetAppInfo(&info);
    app_ref = info.ref;
    Init();
}

RRClientDeskbarView::RRClientDeskbarView(BMessage *msg):BView(msg)
{
	msg->FindRef("app_ref", &app_ref);
	Init();
}

RRClientDeskbarView::~RRClientDeskbarView()
{
}

status_t
RRClientDeskbarView::Archive(BMessage *msg, bool deep) const
{
	status_t err;
	app_info info;

	err = BView::Archive(msg, deep);
	be_app->GetAppInfo(&info);
	msg->AddRef("app_ref", &info.ref);
	msg->AddString("add_on", APP_SIGNATURE);
	return err;
}

BArchivable *
RRClientDeskbarView::Instantiate(BMessage *msg)
{
	if (!validate_instantiation(msg, "RRClientDeskbarView"))
	{
		return NULL;
	}
	return new RRClientDeskbarView(msg);	
}

void
RRClientDeskbarView::Draw(BRect updateRect)
{
    if (bitmap)
    {
        SetDrawingMode(B_OP_OVER);
        DrawBitmap(bitmap, BPoint(0,0));
    }
}

void
RRClientDeskbarView::MouseDown(BPoint where)
{
	ConvertToScreen(&where);
	BMessenger* msngr = new BMessenger(APP_SIGNATURE);
	if ( msngr->IsValid() )
	{
		BMenuItem *selection;
		selection = menu->Go(where);
		if(selection)
		{
			msngr->SendMessage(new BMessage(selection->Command()));
		}
	}
	else
	{
		(new BAlert("Uh-oh", "RRClient2 is not running..\nLaunch it again to be able to remove this replicant..","OK"))->Go();
	}
}

void
RRClientDeskbarView::AttachedToWindow()
{
    BAppFileInfo appInfo;
    BFile file;

    file.SetTo(&app_ref, B_READ_ONLY);
    appInfo.SetTo(&file);
    bitmap = new BBitmap(BRect(0,0,15,15), B_CMAP8,false, false);
    
	appInfo.GetIcon(bitmap, B_MINI_ICON);
	
    if (Parent())
    {
        SetViewColor(Parent()->ViewColor());
    }
}

void
RRClientDeskbarView::DetachedFromWindow()
{
	delete bitmap;
}

void
RRClientDeskbarView::Init(void)
{
	bitmap = NULL;
	BuildMenu();
}

void
RRClientDeskbarView::BuildMenu(void)
{
	menu = new BPopUpMenu("RRClientMenu", false, false, B_ITEMS_IN_COLUMN);
	BMenuItem *About = new BMenuItem("About", new BMessage(B_ABOUT_REQUESTED));
	BMenuItem *Options = new BMenuItem("Options", new BMessage(RRCLIENT_OPTIONS));
	BMenuItem *Exit = new BMenuItem("Exit",new BMessage(RRCLIENT_EXIT));
	
	menu->AddItem(About);
	menu->AddItem(Options);
	menu->AddItem(Exit);
	menu->AddSeparatorItem();
	
	BMenuItem *Login = new BMenuItem("Login", new BMessage(RRCLIENT_LOGIN));
	BMenuItem *Logoff = new BMenuItem("Logoff", new BMessage(RRCLIENT_LOGOFF));
	
	menu->AddItem(Login);
	menu->AddItem(Logoff);
}
