//RRClientOptionsView.cpp

#include "RRClientOptionsView.h"

RRClientOptionsView::RRClientOptionsView(BRect AFrame): BView(AFrame,NULL, B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
{ 	 
	SetViewColor(216, 216, 216, 255);
	
	BRect aRect;
	
	//Save Button
	aRect.Set(180, 120, 245, 140 );
	saveButton = new BButton(aRect, "Save", "Save",new BMessage(RRCLIENT_SAVE_OPTIONS));
	saveButton->MakeDefault( 1 );
	AddChild(saveButton);
	
	//Cancel Button
	aRect.Set(110, 120, 175, 140 );
	cancelButton = new BButton(aRect, "Cancel", "Cancel",new BMessage(RRCLIENT_CANCEL_OPTIONS));
	AddChild(cancelButton);
	
	BuildServerMenu();

	//Location Drop Down
	aRect.Set(10, 20, 240, 40);
	serverlocation = new BMenuField(aRect, "RRClientServersMenuField","Location:",servermenu, B_FOLLOW_LEFT | B_FOLLOW_TOP,  B_WILL_DRAW | B_NAVIGABLE);
	serverlocation->SetDivider(55);
	AddChild(serverlocation);

	//Server Field
	aRect.top = aRect.bottom + 5;
	aRect.bottom = aRect.top + 20;
	serveraddress = new BTextControl(aRect, "servername", "Server:", "", NULL, B_FOLLOW_LEFT | B_FOLLOW_TOP,  B_WILL_DRAW | B_NAVIGABLE);
	serveraddress->SetDivider(55);
	AddChild(serveraddress);

	//Username Field
	aRect.top = aRect.bottom + 5;
	aRect.bottom = aRect.top + 20;
	username = new BTextControl(aRect, "username", "Username:", "", NULL, B_FOLLOW_LEFT | B_FOLLOW_TOP,  B_WILL_DRAW | B_NAVIGABLE);
	username->SetDivider(55);
	AddChild(username);
	
	//Password Field
	aRect.top = aRect.bottom + 5;
	aRect.bottom = aRect.top + 20;
	password = new PassControl(aRect, "password", "Password:", "", NULL);;
	password->SetDivider(55);
	AddChild(password);

	SetOptions(LoadSettings());
}

void
RRClientOptionsView::SetOptions(bool success)
{
	if (success)
	{
		serveraddress->SetEnabled(true);
		serveraddress->SetText(Server);	
		username->SetText(User);
	}
}

void
RRClientOptionsView::Save()
{
	FILE *f = fopen("/boot/beos/etc/rrlms.conf","w");
   
 	if (f != NULL)
 	{
		fputs(serveraddress->Text(), f);
		fputs( " ", f);
		fputs(username->Text(), f);
		fputs( " ", f);
		fputs(password->actualText(), f);
		fclose(f);
 		(new BAlert("Saved!", "Your settings have been updated in\n/boot/beos/etc/rrlms.conf","OK"))->Go();
 	}
	
}

bool
RRClientOptionsView::LoadSettings()
{
  	FILE *f;
  	bool success = false;
 	f=fopen("/boot/beos/etc/rrlms.conf","r");
   
 	if (f != NULL)
 	{
 		success = true;
 		fscanf(f,"%64s %64s %64s",Server, User, Pass);
 		fclose(f);
 	}
 	return(success);
}

void
RRClientOptionsView::BuildServerMenu()
{
	servermenu = new BMenu("Tested Servers...", B_ITEMS_IN_COLUMN);
	BMenuItem *hawaii = new BMenuItem(RR_HAWAII_LOCATION, new BMessage(RR_HAWAII_MSG));
	BMenuItem *rochester = new BMenuItem(RR_ROCHESTER_LOCATION, new BMessage(RR_ROCHESTER_MSG));
	BMenuItem *syracuse = new BMenuItem(RR_SYRACUSE_LOCATION,new BMessage(RR_SYRACUSE_MSG));
	BMenuItem *other = new BMenuItem("Other...",new BMessage(RR_OTHER_MSG));
	
	servermenu->AddItem(hawaii);
	servermenu->AddItem(rochester);
	servermenu->AddItem(syracuse);
	servermenu->AddItem(other);
	servermenu->SetRadioMode(true);
	servermenu->SetLabelFromMarked(true);
}
